#include "stdafx.h"
const float speedfactor = 1.5;

#define ToRad (3.141592654/180)
#define pW al_get_bitmap_width(pl)
#define pH al_get_bitmap_height(pl)

std::list<Particle*> Particle::Particlesystem;

Particle::Particle(int speed,int lifetime,int w,int X,int Y,int Angle,int R,int G,int B,int Rv,int Gv,int Bv,float val,int W,int H,int id,int Px,int Py)
{
	px = Px;
	py = Py;
	CW = W;
	CH = H;
	v = val;
	sd = speed*4;
	lf = rand()%60-30+lifetime;
	width = w;
	x = X;
	y = Y;
	if(rand()%8==0)
	{
		r = 255-Rv;
		g = 255-Gv;
		b = 255-Bv;
		rv = 255-R;
		gv = 255-G;
		bv = 255-B;
	}
	else
	{
		r = R;
		g = G;
		b = B;
		rv = Rv;
		gv = Gv;
		bv = Bv;
	}
	rv = rv == 0 ? 1: rv;
	gv = gv == 0 ? 1: gv;
	bv = bv == 0 ? 1: bv;
	w = w == 0 ? 1 : w;
	float ch = Angle+rand()%w-w/2;
	float from = sd/speedfactor;
	float to = sd*speedfactor;
	sd = rand()%(int)(to-from)+from;
	vx = cos(ch*ToRad)*(sd);
	vy = sin(ch*ToRad)*(sd);

	Particlesystem.push_back(this);
}

Particle::~Particle(void)
{
}


void Particle::Update(double speed)
{
	lf -= speed;
	if(x<=0||x>=CW)
		vx=-vx;
	if(y<=0||y>=CH)
		vy=-vy;
	x+=vx*speed;
	y+=vy*speed;

	

	vx*=1-0.05*speed*60;
	vy*=1-0.05*speed*60;
}

void Particle::UpdateAll(double speed)
{
	std::list<Particle*>::iterator i;
	for(i = Particlesystem.begin(); 
		i!= Particlesystem.end();
		++i)
	{
		(*i)->Update(speed);
		if ((*i)->lf<=0||Pos((*i)->vx)+Pos((*i)->vy)<0.0001)
		{
			delete *i;
			i = Particlesystem.erase(i);
			if(i==Particlesystem.end())
				break;
		}
	}
}

void Particle::Draw()
{
	if(!OutOfScreen(x-VsX,y-VsY,1,1))
	{
		float f = MIN(sqrt(qdr(vx)+qdr(vy))/100*v,v*3);
		al_set_blender(ALLEGRO_ADD, ALLEGRO_ALPHA,ALLEGRO_ONE);
		al_draw_tinted_scaled_rotated_bitmap(particle,al_map_rgb(r+rand()%rv,g+rand()%gv,b+rand()%bv), al_get_bitmap_width(particle)/2,al_get_bitmap_height(particle)/2,x-VsX,y-VsY,2*f,f,atan2(vy,vx),0);
	}
}


void Particle::DrawAll()
{
	std::list<Particle*>::iterator i;
		for(i = Particlesystem.begin(); i!= Particlesystem.end();++i)
			(*i)->Draw();
}

void createparticles(int anz,int speed,double lifetime,int w,int X,int Y,int Angle,int R,int G,int B,int Rv,int Gv,int Bv)
{
	for(int i = 0; i!=anz;++i)
		new Particle(speed, lifetime, w, X, Y, Angle, R, G, B, Rv, Gv, Bv);
}

bool OutOfField(int x,int y,int w,int h)
{
	if(x<=0||x+w>=VsW||y<=0||y+h>=VsH)
		return true;
	return false;
}

bool OutOfScreen(int x,int y,int w,int h)
{
	if(x<=0||x+w>=SCREEN_W||y<=0||y+h>=SCREEN_H)
		return true;
	return false;
}

float Pos(float f)
{
	if(f<0)
		return -f;
	return f;
}

int MIN(int a,int b)
{
	if(a < b)  return a; else return b;
}

float qdr(float f)
{
	return f*f;
}