// ParticleTest.cpp : Definiert den Einstiegspunkt fr die Anwendung.
//

#include "stdafx.h"
#include "ParticleTest.h"

#define PRESS 1

int VsW = 1024;
int VsH = 786;
int VsX  = 0;
int VsY = 0;
int SCREEN_W = 800;
int SCREEN_H = 600;

ALLEGRO_BITMAP* particle;
ALLEGRO_EVENT_QUEUE* queue;
ALLEGRO_EVENT event;


bool gameopen = true;
char key[256];
int mouse_x = 0;
int mouse_y = 0;
int mouse_dx = 0;
int mouse_dy = 0;
int mouse_b = 0;
double altime, old_time = 0;

#ifdef _WIN32
#undef main
#endif


void MainRout()
{
	while(gameopen) 
	{
		// Block until an event enters the queue
		al_wait_for_event(queue, &event);
		ALLEGRO_KEYBOARD_STATE aks;
		al_get_keyboard_state(&aks);
		for(int i = 0; i!= 256;++i)
		    key[i] = al_key_down(&aks,i);
		if(key[ALLEGRO_KEY_ESCAPE])
			gameopen = false;

		switch(event.type) 
		{
			case ALLEGRO_EVENT_MOUSE_AXES:
			{
				mouse_x = event.mouse.x;
				mouse_y = event.mouse.y;
				mouse_dx = event.mouse.dx;
				mouse_dy = event.mouse.dy;
				break;
			}
			case ALLEGRO_EVENT_MOUSE_BUTTON_UP:
			case ALLEGRO_EVENT_MOUSE_BUTTON_DOWN:
			{
				ALLEGRO_MOUSE_STATE* ams = new ALLEGRO_MOUSE_STATE();
				al_get_mouse_state(ams);
				mouse_b = ams->buttons;
				break;
			}
			case ALLEGRO_EVENT_DISPLAY_CLOSE:
			{
				gameopen = false;
				break;
			}
		}
	}
}

int main(int argc,char** argv)
{
	al_init();
	al_init_font_addon();
	al_init_ttf_addon();
	al_init_image_addon();
	al_install_keyboard();
	al_install_mouse();
	//1. Display
	ALLEGRO_DISPLAY* adStart = al_create_display(SCREEN_W,SCREEN_H);
	//Loading
	ALLEGRO_FONT* f = al_load_ttf_font("Times.ttf",20,0);
	if(!f)
	{
		printf("Times.ttf konnst nicht geladen werden");
		exit(-1);
	}
	if(!(particle = al_load_bitmap("particle.png")))
	{
		printf("particle.png konnte nicht geladen werden");
		exit(-1);
	}

	// Start the event queue to handle keyboard input and our timer
	queue = al_create_event_queue();
	al_register_event_source(queue, (ALLEGRO_EVENT_SOURCE*)al_get_mouse_event_source());
	al_register_event_source(queue, al_get_display_event_source(adStart));
	CreateThread(0,0,(LPTHREAD_START_ROUTINE) MainRout,0,0,0);

	while(gameopen)
	{
		altime = al_current_time();
		double dt = altime-old_time;
		old_time = al_current_time();
		double fps = 1 / dt;

		Particle::UpdateAll(dt);													//Partikel updaten, Dauer des Updatevorgangs bergeben (zur Berechnung)
		if(mouse_b)
			createparticles(
			100,	//Anzahl der Partikel
			300,	//Geschwindigkeit (Pixel/s)
			5,		//Lebensdauer in Sekunden
			360,	//Breite (Winkel) der Ausstorichtung
			mouse_x,mouse_y,//Position
			0,	//Ausstorichtung (Winkel)
			255,//Zufallsfarbwerte von 0-255, Start rot
			90,	//Start grn
			0,	//Start blau
			0,	//Rotbereich (lnge)
			255,//Grn
			0);	//Blau

		al_set_blender(ALLEGRO_ADD, ALLEGRO_ALPHA, ALLEGRO_INVERSE_ALPHA);	//Screen lschen
		al_clear_to_color(al_map_rgb(0,0,0));
		Particle::DrawAll();														//Partikel zeichnen
		al_set_blender(ALLEGRO_ADD, ALLEGRO_ALPHA,ALLEGRO_INVERSE_ALPHA);
		al_draw_textf(f, al_map_rgb_f(1,1,1), 2, 2, 0, "Fps: %d", (int)fps);								//Fps Info zeichnen
		al_flip_display();
	}

	//1. Display Close and destroy
	al_destroy_bitmap(particle);
	al_destroy_display(adStart);

	//Destroying Data
	al_destroy_font(f);
	return 0;
}